#include "pktfec.h"

#include <stdlib.h>
#include <stdio.h>

#define MAXPKTLEN 2048

static void makesoft(float *out, uint8_t *in, size_t bytes) {
  int i;
  for (i=0; i<8*bytes; i++) {
    if (in[i/8] & (0x80 >> (i%8))) out[i] = -1.0;
    else out[i] = 1.0;
  }
}

int main(int argc, char **argv) {
  pktfec_decoder_t decoder;
  uint8_t *input;
  size_t inputlen;
  float *softinput;
  uint8_t *output;
  input = malloc(PKTFEC_BLOCKLEN);
  if (!input) return 1;
  inputlen = fread(input, 1, PKTFEC_BLOCKLEN, stdin);
  if (ferror(stdin)) return 1;
  softinput = malloc((8*PKTFEC_BLOCKLEN) * sizeof(float));
  if (!softinput) return 1;
  makesoft(softinput, input, inputlen);
  free(input);
  if (!pktfec_decode_start(&decoder, softinput, 8*inputlen)) return 1;
  if (decoder.outputlen > MAXPKTLEN) return 1;
  free(softinput);
  input = malloc(decoder.extralen * sizeof(float));
  if (decoder.extralen) inputlen = fread(input, 1, decoder.extralen, stdin);
  if (ferror(stdin)) return 1;
  softinput = malloc((8*decoder.extralen) * sizeof(float));
  if (!softinput) return 1;
  makesoft(softinput, input, inputlen);
  free(input);
  output = malloc(decoder.outputlen * sizeof(uint8_t));
  if (!output) return 1;
  if (!pktfec_decode_finish(&decoder, output, softinput, 8*inputlen)) return 1;
  fwrite(output, 1, decoder.outputlen, stdout);
  if (ferror(stdout)) return 1;
  return 0;
}
